// from mp3 package  included on dctonic cd

#include <kallisti/abi/fs.h>
#include "filelist.h"

extern abi_fs_t *fs;

char pathname[512] = "/rd/";

filelist_t * make_fake_entries(filelist_t *list)
{
    filelist_t *new = list;

    strcpy(new->realname, ".");
    strcpy(new->dispname, "./");
    new->size = -1;

    new->next = malloc(sizeof(filelist_t));
    ((filelist_t *)new->next)->prev = new;
    new = new->next;

    strcpy(new->realname, "..");
    strcpy(new->dispname, "../");
    new->size = -1;

    new->next = malloc(sizeof(filelist_t));
    ((filelist_t *)new->next)->prev = new;
    new = new->next;

    return new;
}

void build_list(filelist_t * list)
{
    dirent_t *de;
    uint32 hnd;
    filelist_t *new;

    if (!list)
	return;

    hnd = fs->open(pathname, O_RDONLY | O_DIR);

    if (!hnd) {
	strcpy(pathname, "/cd/");
	hnd = fs->open(pathname, O_RDONLY | O_DIR);
    }

    new = list;
    new->next = 0;
    new->prev = 0;

    de = fs->readdir(hnd);

    if (de) {
	if (strcmp(de->name, "."))
	    new = make_fake_entries(list);
    }

    while (de) {
	strcpy(new->realname, de->name);
	memcpy(new->dispname, new->realname, 78);
	new->dispname[79] = 0;
	new->size = de->size;
	if (de->size == -1)
	    if (strlen(new->realname) > 77) {
		new->dispname[75] = '.';
		new->dispname[76] = '.';
		new->dispname[77] = '.';
		new->dispname[78] = '/';
	    } else {
		new->dispname[strlen(new->dispname)+1] = 0;
		new->dispname[strlen(new->dispname)] = '/';
	    }
	else if (strlen(new->realname) > 78) {
	    new->dispname[76] = '.';
	    new->dispname[77] = '.';
	    new->dispname[78] = '.';
	}	

	de = fs->readdir(hnd);

	if (de) {
	    new->next = malloc(sizeof(filelist_t));
	    ((filelist_t *)new->next)->prev = new;
	    new = new->next;
	}
	    new->next = 0;
    }
    fs->close(hnd);
    
}

void destroy_list(filelist_t *list)
{
    filelist_t *item = list;

    if (!list)
	return;

    while(item->next)
	item = item->next;

    while(item->prev) {
	item = item->prev;
	free(item->next);
    }
}
